function [ XYZ ] = Lab2XYZ( Lab,XYZn )
%input: Lab:3-by-n array of CIELAB values, XYZn...3-by-n vector as illuminant white point
%output: XYZ...3-by-n tristimulus values

Xn = XYZn(1,1); Yn = XYZn(2,1); Zn = XYZn(3,1); 
L = Lab(1,:); a = Lab(2,:); b = Lab(3,:); 

finvx = (L+16)/116+a/500;
finvy = (L+16)/116;
finvz = (L+16)/116-b/200;

X = Xn*finvx.^3;
Y = Yn*finvy.^3;
Z = Zn*finvz.^3;

idxx = (finvx<=6/29); idxy = (finvy<=6/29); idxz = (finvz<=6/29); 
X(idxx) = 3*(6/29)^2*(finvx(idxx)-4/29);
Y(idxy) = 3*(6/29)^2*(finvy(idxy)-4/29);
Z(idxz) = 3*(6/29)^2*(finvz(idxz)-4/29);

XYZ = cat(1,X,Y,Z);

end

