function [ Lab ] = XYZ2Lab( XYZ,XYZn )
%input: XYZ...3-by-n tristimulus values, XYZn...3-by-1 vector as illuminant white point
%output: Lab:3-by-n array of CIELAB values

ratio = diag(1./XYZn)*XYZ;

fXYZ = ratio.^(1/3);
idx = (ratio<=0.008856);
fXYZ(idx) = 7.787*ratio(idx)+16/116;


fX = fXYZ(1,:); fY = fXYZ(2,:); fZ = fXYZ(3,:); 

L = 116*fY-16;
a = 500*(fX-fY);
b = 200*(fY-fZ);

Lab = cat(1,L,a,b);


end

