function [ spd_ill ] = calcIll( spd_ref, ill_relative, def_cmf, L_target )
% calc spd_ill so that spd_ref has L* = L_target
% ill_relative is the relative spd of illuminant (reference white)
%{

e.g. input

spd_ref = cie.illA; 
ill_relative = cie.illA; 
def_cmf = cie.cmf10deg; 
L_target = 50; 

This will produce... 
spd_ill is computed such that L* of spd_ill = 50 for CIE 1964 observer

%}

t_XYZ_ref = 683*def_cmf'*spd_ref; 
t_Y = t_XYZ_ref(2);

t_ratioYYn = ((L_target+16)/116).^3; % Y/Yn
t_Yn = t_Y/t_ratioYYn;

t_XYZ_ill = 683*def_cmf'*ill_relative; 
spd_ill = t_Yn/t_XYZ_ill(2) * ill_relative; % refW (so that L* of SPD_ref = 50)

end

