%originally created in Jim's class
%modified 2012/06/26
%modified 2012/09/21 changed loading csv & txt files to xlsread for Matlab2012a
% modified 2012/12/01 

function [ cie ] = getCieStruct(varargin)
% varargin{1}: lambda e.g. 380:5:780
% varargin{2}: interpolation method e.g. 'linear'

addpath('../MATLAB/ColorToolbox/Database');


%% Color Matching Functions
t_2deg = load('ciexyz31_1.csv'); %360:1:830
t_2degMod = load('ciexyzjv.csv'); %380:5:825
t_10deg = load('ciexyz64_1.csv'); %360:1:830

% Reference: http://cvrl.ioo.ucl.ac.uk/


%% Illuminant
t_t_IllAnD65 = xlsread('all_1nm_data_illA_illD65.xls'); 
t_IllA = t_t_IllAnD65(:,[1 2]); % 300:1:830
t_IllD65 = t_t_IllAnD65(:,[1 3]); % 300:1:830
t_IllF = xlsread('CIE_IllF_1-12_380-780-5nm.xls'); %380:5:780
t_IllEig = xlsread('CIE_eigD_380-780-5nm.xls'); %380:5:780

%Reference for A,D65,F: http://www.cis.rit.edu/mcsl/online/cie.php


%% Output

%default wavelength range is 380:5:780, default interpolation is 'spline'

if nargin==0 
    cie.lambda = [380:5:780]; 
    interpolation = 'spline'; 
elseif nargin==1
    cie.lambda = varargin{1}; 
    interpolation = 'spline'; 
elseif nargin==2
    cie.lambda = varargin{1}; 
    interpolation = varargin{2}; 
end


cie.cmf2deg = interp1(t_2deg(:,1),t_2deg(:,2:4),cie.lambda,interpolation);
cie.cmf2degMod = interp1(t_2degMod(:,1),t_2degMod(:,2:4),cie.lambda,interpolation);
cie.cmf10deg = interp1(t_10deg(:,1),t_10deg(:,2:4),cie.lambda,interpolation);

cie.illA = interp1(t_IllA(:,1),t_IllA(:,2),cie.lambda,interpolation)';
cie.illD65 = interp1(t_IllD65(:,1),t_IllD65(:,2),cie.lambda,interpolation)';
cie.illE = 100*ones(length(cie.lambda),1);
cie.illF = interp1(t_IllF(:,1),t_IllF(:,2:13),cie.lambda,interpolation);
cie.eigD = interp1(t_IllEig(:,1),t_IllEig(:,2:4),cie.lambda,interpolation);




end

