%{
This script is an example to use categorical observers



<Input>
n_cat: # of categorical observers, default is 10
fs: field size (visual angle in degree)
list_Age: % age distribution, can be a single number if interested in a specific age group



<Output>
CMFs_LMS_CatObs(79x3xn_cat): area-normalized lms-CMFs (cone fundamentals)
for categorical observers
dim1: wavelength sampling from 390nm to 780nm at 5nm interval
dim2: i-th cone(L,M,S)
dim3: i-th categorical observer

Age_CatObs(1xn_cat): age for i-th categorical observer

pFctr_CatObs(n_catx8): Eight physiological parameters for each row
row: i-th categorical observer


The example here generates 10 categorical observers for field size of 2-degree

%}

clear all; 
n_cat = 10; % # of categorical observers, default is 10
fs = 2; % field size (visual angle in degree)

[ CMFs_LMS_CatObs, Age_CatObs, pFctr_CatObs ] = fnc_getCatObs( n_cat,fs ); 



%% Plot

figure; hold on; grid on; 
k = 1; plot(390:5:780, squeeze(CMFs_LMS_CatObs(:,k,:)), 'Color', 'r'); 
k = 2; plot(390:5:780, squeeze(CMFs_LMS_CatObs(:,k,:)), 'Color', 'g'); 
k = 3; plot(390:5:780, squeeze(CMFs_LMS_CatObs(:,k,:)), 'Color', 'b'); 

