function [ dE ] = obj_RayleighMatch( coef, SPD_RG, SPD_Y, SPD_refW, cmf, cie )
% coef is 2x1 to scale SPD_RG

% Get adjusted SPDs (luminance of SPD_RGadj doesn't change for def_cmf)
SPD_Y = coef(1)*SPD_Y; 
SPD_RGadj = coef(2)*SPD_RG(:,1) + (1-coef(2))*SPD_RG(:,2); 

% Get Transformed cmf
[ t_cmf_trans , t ] = cmfA2cmfB( cmf , cie.cmf10deg );

% Compute XYZ for ref, adj, referenceWhite
t_XYZ_1 = 683*t_cmf_trans'*SPD_Y;
t_XYZ_2 = 683*t_cmf_trans'*SPD_RGadj;
t_XYZ_W = 683*t_cmf_trans'*SPD_refW;

% Compute Lab for ref, adj 
t_LAB_1 = XYZ2Lab(t_XYZ_1,t_XYZ_W);
t_LAB_2 = XYZ2Lab(t_XYZ_2,t_XYZ_W);

dE = deltaE00(t_LAB_1,t_LAB_2); 

end

